﻿if select(2, UnitClass("player")) ~= "SHAMAN" then return end

local simGlyph = { [63271] = "Feral_Spirit", [55455] = "Fire_Elemental_Totem", [55447] = "Flame_Shock", [55451] = "Flametongue_Weapon", [55454] = "Lava_Burst", [55444] = "Lava_Lash", [55453] = "Lightning_Bolt", [55442] = "Shocking", [55446] = "Stormstrike", [55436] = "Water_Shield", [55445] = "Windfury_Weapon", [55449] = "Chain_Lightning",}

StaticPopupDialogs["SIM_EXPORT"] = {
    text = ENHSIMEXPORTPOPUP,
    button1 = OKAY,
    button2 = CANCEL,
    timeout = 0,
    OnAccept = function()
		export()
    end,
    OnCancel = function()
    end,
    whileDead = 1,
    hideOnEscape = 1,
}

function export()
	enhsimexportframeScrollFrameText:SetText("")
	local text = enhsimexportframeScrollFrameText
	text:Insert("#####################################")
	text:Insert("\n## TribalEnhancement EnhSim Export ##")
	text:Insert("\n#####################################\n")
	text:Insert("\nrace "..select(2, UnitRace("player")))
	local dps, speed, enchant, weapon = TeGetWeaponInfo()
	text:Insert("\nmh_speed "..speed[16])
	text:Insert("\noh_speed "..speed[17])
	text:Insert("\nmh_dps "..dps[16])
	text:Insert("\noh_dps "..dps[17])
	text:Insert("\nmh_crit "..GetCritChance())
	text:Insert("\noh_crit "..GetCritChance())
	text:Insert("\nmh_hit "..GetCombatRatingBonus(6)+6)
	text:Insert("\noh_hit "..GetCombatRatingBonus(6)+6)
	text:Insert("\nmh_expertise_rating "..GetCombatRating(24))
	text:Insert("\noh_expertise_rating "..GetCombatRating(24))
	local base, posBuff, negBuff = UnitAttackPower("player")
	text:Insert("\nap "..base+posBuff+negBuff)
	text:Insert("\nmelee_haste "..GetCombatRatingBonus(18))
	text:Insert("\nstr "..UnitStat("player", 1))
	text:Insert("\nagi "..UnitStat("player", 2))
	text:Insert("\nint "..UnitStat("player", 4))
	text:Insert("\nspi "..UnitStat("player", 5))
	text:Insert("\nmastery_rating "..GetCombatRating(26))
	text:Insert("\nspellpower "..GetSpellBonusDamage(4))
	text:Insert("\nspell_crit "..GetSpellCritChance(4))
	text:Insert("\nspell_hit "..GetCombatRatingBonus(8))
	text:Insert("\nspell_haste "..GetCombatRatingBonus(20))
	text:Insert("\nmax_mana "..UnitManaMax("player"))
	text:Insert("\nmp5 "..select(2, GetManaRegen())*5)
	
	text:Insert("\n\nmh_imbue -")
	text:Insert("\noh_imbue -")

	text:Insert("\n\nmh_enchant "..enchant[16])
	text:Insert("\noh_enchant "..enchant[17])
	
	text:Insert("\n\nmh_weapon "..weapon[16])
	text:Insert("\noh_weapon "..weapon[17])
	
	local trinket1 = GetInventoryItemID("player", 13) or "-"
	text:Insert("\n\ntrinket1 "..trinket1)
	local trinket2 = GetInventoryItemID("player", 14) or "-"
	text:Insert("\ntrinket2 "..trinket2)
	
	local setBonus, armorBonus = TeGetSetBonus()
	text:Insert("\n\nset_bonus1 "..setBonus)
	text:Insert("\nset_bonus2 -")
	text:Insert("\nset_bonus3 -")
	
	local gem1 = GetInventoryItemGems(1) or "-"
	text:Insert("\n\nmetagem "..gem1)
	
	playerGlyph = TeGetPlayerGlyph()
	text:Insert("\n\nglyph_prime1 "..playerGlyph[4])
	text:Insert("\nglyph_prime2 "..playerGlyph[5])
	text:Insert("\nglyph_prime3 "..playerGlyph[6])
	
	text:Insert("\n\nglyph_major1 "..playerGlyph[1])
	text:Insert("\nglyph_major2 "..playerGlyph[2])
	text:Insert("\nglyph_major3 "..playerGlyph[3])
	
	text:Insert("\n\narmor_type_bonus "..armorBonus)
	
	if CurrentSpec == "enhanc" then
		text:Insert("\n\nprimary_talent enhancement")
	elseif CurrentSpec == "elem" then
		text:Insert("\n\nprimary_talent elemental")
	else
		text:Insert("\n\nprimary_talent -")
	end
	text:Insert("\nelemental_weapons "..select(5, GetTalentInfo(2,1)))
	text:Insert("\nfocused_strikes "..select(5, GetTalentInfo(2,2)))
	text:Insert("\nimproved_shields "..select(5, GetTalentInfo(2,3)))
	text:Insert("\nelemental_devastation "..select(5, GetTalentInfo(2,4)))
	text:Insert("\nflurry "..select(5, GetTalentInfo(2,5)))
	text:Insert("\nstatic_shock "..select(5, GetTalentInfo(2,10)))
	text:Insert("\nimproved_fire_nova "..select(5, GetTalentInfo(2,12)))
	text:Insert("\nsearing_flames "..select(5, GetTalentInfo(2,13)))
	text:Insert("\nfrozen_power "..select(5, GetTalentInfo(2,11)))
	text:Insert("\nshamanistic_rage "..select(5, GetTalentInfo(2,15)))
	text:Insert("\nunleashed_rage "..select(5, GetTalentInfo(2,16)))
	text:Insert("\nimproved_lava_lash "..select(5, GetTalentInfo(2,18)))
	text:Insert("\nmaelstrom_weapon "..select(5, GetTalentInfo(2,17)))
	
	text:Insert("\n\nconvection "..select(5, GetTalentInfo(1,2)))
	text:Insert("\nconcussion "..select(5, GetTalentInfo(1,3)))
	text:Insert("\ncall_of_flame "..select(5, GetTalentInfo(1,4)))
	text:Insert("\nreverberation "..select(5, GetTalentInfo(1,6)))
	text:Insert("\nelemental_precision "..select(5, GetTalentInfo(1,7)))
	text:Insert("\nelemental_focus "..select(5, GetTalentInfo(1,9)))
	text:Insert("\nelemental_oath "..select(5, GetTalentInfo(1,11)))
	text:Insert("\nlava_flows "..select(5, GetTalentInfo(1,12)))
	text:Insert("\nstorm_earth_and_fire 0")
	text:Insert("\nelemental_mastery "..select(5, GetTalentInfo(1,14)))
	text:Insert("\nfeedback "..select(5, GetTalentInfo(1,17)))
	text:Insert("\nlava_surge "..select(5, GetTalentInfo(1,18)))
	
	enhsimexportframe:Show()
	enhsimexportframeScrollFrameText:SetFocus()
end

function TeGetWeaponInfo()
	local speed, dps, enchant, weapon = {},{},{},{}
	local tooltip = CreateFrame('GameTooltip', 'tooltip', UIParent, 'GameTooltipTemplate')
	tooltip:SetOwner(UIParent, 'ANCHOR_NONE')
	
	for k = 16, 17 do
		local link = GetInventoryItemLink("player", k)
		if link then local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(link, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?") end
		if Enchant ~= "0" and Enchant ~= nil then enchant[k] = Enchant else enchant[k] = "-" end
		tooltip:ClearLines()
		if link then tooltip:SetHyperlink(link) end
		for i = 1, 8 do
			local tooltipleft, tooltipright = _G["tooltipTextLeft"..i], _G["tooltipTextRight"..i]
			if tooltipleft:GetText() and string.match(tooltipleft:GetText(), "%((%d+%.%d+)") then
				dps[k] = string.match(tooltipleft:GetText(), "%((%d+%.%d+)")
			elseif not dps[k] then dps[k] = "-" end
			if tooltipright:GetText() and string.match(tooltipright:GetText(), "(%d+%.%d+)$") then
				speed[k] = string.match(tooltipright:GetText(), "(%d+%.%d+)$")
			elseif not speed[k] then speed[k] = "-" end
			if tooltipright:GetText() and string.match(tooltipright:GetText(), "^([%a%s]+)$") then
				if string.match(tooltipright:GetText(), "^([%a%s]+)$") == AXE then weapon[k] = "Axe"
				elseif string.match(tooltipright:GetText(), "^([%a%s]+)$") == DAGGER then weapon[k] = "Dagger"
				elseif string.match(tooltipright:GetText(), "^([%a%s]+)$") == FIST then weapon[k] = "Fist"
				elseif string.match(tooltipright:GetText(), "^([%a%s]+)$") == MACE then weapon[k] = "Mace" end
			elseif not weapon[k] then weapon[k] = "-" end
		end
	end
	
	tooltip:Hide()
	tooltip = nil
	return dps, speed, enchant, weapon
end

function TeGetSetBonus()
	local T11, armorBonus = 0,0
	for i = 1, 10 do
		local itemId = GetInventoryItemID("player", i)
		if itemId then
			local _, _, _, _, _, _, itemSubType = GetItemInfo(itemId)
			if itemSubType == MAIL then armorBonus = armorBonus + 1 end
		end
		for j = 60318, 60322 do
			if itemId == j then T11 = T11 + 1 end
		end
		for j = 65249, 65253 do
			if itemId == j then T11 = T11 + 1 end
		end
	end
	if armorBonus == 8 then armorBonus = 1 else armorBonus = 0 end
	if T11 >= 4 then
		return "t11_battlegear_4", armorBonus
	elseif T11 >= 2 and T11 < 4 then
		return "t11_battlegear_2", armorBonus
	else
		return "-", armorBonus
	end
end

function TeGetPlayerGlyph()
	local playerGlyph = {}
	for i = 1, NUM_GLYPH_SLOTS do
		local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i)
		if glyphType ~= 1 then
			table.insert(playerGlyph, simGlyph[glyphSpellID] or "-")
		end
	end
	return playerGlyph
end
